Object subclass: #DNS
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebAlgo'!
!DNS commentStamp: '<historical>' prior: 0!
A DNS.

Instance Variables
	cache:		<Dictionary>

cache
	- All url already resolved by  dns
!


!DNS methodsFor: 'as yet unclassified' stamp: 'DS 9/18/2014 15:00'!
initialize
	cache := Dictionary newFrom: { 
		'www.google.com'  -> '64.233.176.99'.
		'www.fi.uba.ar'		-> '157.92.49.18'.
		'www.yahoo.com'	-> '98.139.180.149'
	}.! !

!DNS methodsFor: 'as yet unclassified' stamp: 'DS 9/18/2014 15:41'!
uri: aUrl 
	( cache includesKey: aUrl ) ifTrue: [
		^cache at: aUrl.
	].

	UnknownUrl signal.! !


Object subclass: #Firefox
	instanceVariableNames: 'dns cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebAlgo'!
!Firefox commentStamp: '<historical>' prior: 0!
A Konqueror is a browser.

Instance Variables
	cache:		<Dictionary>
	dns:		<DNS>

cache
	- uris already retrieved

dns
	- DNS service
!


!Firefox methodsFor: 'private' stamp: 'DS 9/18/2014 14:31'!
dns: aDns
	dns := aDns.! !


!Firefox methodsFor: 'as yet unclassified' stamp: 'DS 9/18/2014 15:17'!
initialize
	cache := Dictionary newFrom: { 
		'64.233.176.99'	-> '<html><head><title>Google</title></head><body></body></html>'.
		'157.92.49.18'		-> '<html><body><h1>Facultad de Ingenieria UBA</body></html>'.
		'98.139.180.149'	-> '<html></html>'.
	}.! !

!Firefox methodsFor: 'as yet unclassified' stamp: 'DS 9/18/2014 15:39'!
open: aUrl 
	| uri |
	[ 
		uri :=  dns uri: aUrl.
		^self connects: uri.
	] 
	on: UnknownUrl, ServerUnreachable 
	do: [ 
		ServerUnreachable signal.
	]
	
! !

!Firefox methodsFor: 'as yet unclassified' stamp: 'DS 9/18/2014 15:36'!
connects: aUri
	(cache includesKey: aUri) ifTrue: [ 
		^cache at: aUri.
	].

	ServerUnreachable signal.
	
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Firefox class
	instanceVariableNames: ''!

!Firefox class methodsFor: 'as yet unclassified' stamp: 'DS 9/18/2014 15:11'!
withDns: aDns
	| result |
	result := self new dns: aDns.
	^result.! !


Error subclass: #ServerUnreachable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebAlgo'!
!ServerUnreachable commentStamp: '<historical>' prior: 0!
A ServerUnreachable is thrown whenever a connection cannot be stablished.
!


Error subclass: #UnknownUrl
	instanceVariableNames: 'missingUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebAlgo'!
!UnknownUrl commentStamp: '<historical>' prior: 0!
An UnknownUrl is thrown when url cannot be resolved by DNS.
!


!UnknownUrl methodsFor: 'as yet unclassified' stamp: 'DS 5/14/2020 19:36'!
signalForUrl: aUrlAsString 
	missingUrl := aUrlAsString .
	
	self signal: missingUrl.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

UnknownUrl class
	instanceVariableNames: ''!

!UnknownUrl class methodsFor: 'as yet unclassified' stamp: 'DS 5/14/2020 19:35'!
signalForUrl: aUrlAsString 
	|result|
	result := self new.
	result signalForUrl: aUrlAsString .
	^result.! !
